import PyCara.PyCaraProcess as PyCaraProcess
from collections import defaultdict

########################################
# Obtain all the properties and display 
#  them by group
#

cara = PyCaraProcess.CaraProcess()

# get a dictionary with all the properties 
properties = cara.get_properties()       
        
# generate a new dict where keys are property group names,
# and the values are dicts mapping property name to property value 
v = defaultdict( dict)
for key,value in properties.iteritems():
    first_dot_pos = key.find('.')
    group = key[0:first_dot_pos]
    v[group][key] = value
       

# print all the groups
for groups in sorted(v.iterkeys()):
    print groups
print("")
       
# now print all the properties in the "BlobParameters" group
       
group = 'BlobParameters'
print(group)
for name in sorted(v[group].iterkeys()):
    print("    {} : {}".format( name, v[group][name] )) 
print("")
    
# and now, all the properties in the "Tracking" group    
group = 'TrackingParameters'
print(group)
for name in sorted(v[group].iterkeys()):
    print("    {} : {}".format( name, v[group][name] )) 

    