import PyCara.PyCaraExport as PyCaraExport
import argparse
import sys
import os


########################################
# Export 3d data for a calibration brim
#

parser = argparse.ArgumentParser()
parser.add_argument('filename', help='filename', nargs='?' )
args = parser.parse_args()

filename = args.filename

if filename == None:
    print "Must supply a filename"
    sys.exit(1)

cara = PyCaraExport.CaraExport()
if not cara.open( filename ):
    print "failed to open cara file [{}]".format(filename)
    sys.exit(1)
    
for i in cara.brim_points():
    X = cara.point_position(i, 0)
    print "{} {} {}".format(X[0], X[1], X[2])
sys.exit(0)
